{--
For bicycle(s) offered by Tom Jones, list the item number, description, highest bid (if any), and name of the highest bidder, ordered by item number.
--}
import schema namespace bid = "http://www.xquark.org/XQuery/use-cases/bids" at "bids.xsd"
<result>
  {
    for $seller in collection("users")/*:users,
        $buyer in  collection("users")/*:users,
        $item in  collection("items")/*:items,
        $highbid in  doc("bids.xml")/bid:bids/bid_tuple
    where $seller/name = "Tom Jones" 
      and $seller/userid = $item/offered_by 
      and contains($item/description, "Bicycle") 
      and $item/itemno = $highbid/itemno 
      and $highbid/userid = $buyer/userid 
      and $highbid/bid = max(doc("bids.xml")/bid:bids/bid_tuple
                               [itemno = $item/itemno]/bid)
    return
        <jones_bike>
            { $item/itemno }
            { $item/description }
            <high_bid>{ $highbid/bid }</high_bid>
            <high_bidder>{ $buyer/name }</high_bidder>
        </jones_bike>
    sortby(itemno)
  }
</result>
