(:
List all registered users in order by userid; for each user, include the userid, name, 
and an indication of whether the user is active (has at least one bid on record) 
or inactive (has no bid on record).
:)
import schema namespace bid = "http://www.xquark.org/XQuery/use-cases/bids" at "bids.xsd"

<result>
  {
    for $u in collection("users")/*:users
    let $b := doc("bids.xml")/bid:bids/bid_tuple[userid = $u/userid]
    order by $u/userid
    return
        <user>
            { $u/userid }
            { $u/name }
            {
                if (empty($b))
                  then <status>inactive</status>
                  else <status>active</status>
            }
        </user>
  }
</result>

