{--
List all users in alphabetic order by name. For each user, include descriptions of all the items (if any) that were bid on by that user, in alphabetic order. 
--}
import schema namespace bid = "http://www.xquark.org/XQuery/use-cases/bids" at "bids.xsd"
<result>
  {
    for $u in collection("users")/*:users
    return
        <user>
            { $u/name }
            {
                for $b in distinct-values(doc("bids.xml")/bid:bids/bid_tuple[userid = $u/userid]/itemno),
                    $i in collection("items")/*:items[itemno = $b]
                return
                    <bid_on_item>{ $i/description/text() }</bid_on_item>
                sortby(.)
            }
        </user>
    sortby(name)
  }
</result>

