drop table "publisher";
drop table "editor";
drop table "author";
drop table "person";
drop table "book";

create table "book" (
	"id" 		varchar(10) primary key,
	"title"		varchar(80) not null,
	"year"		decimal not null,
	"pubid"		varchar(10) not null
);

create table "person" (
	"id"			varchar(10) primary key,
	"first"			varchar(30),
	"last"			varchar(30) not null,
	"affiliation"	varchar(30)
);

create table "author" (
	"bookid"		varchar(10) not null,
	"personid"		varchar(10) not null,
	"rank"			decimal(2) not null
);

create table "editor" (
	"bookid"		varchar(10) not null,
	"personid"		varchar(10) not null,
	"rank"			decimal(2) not null
);

create table "publisher" (
	"id"		varchar(10) primary key,
	"name"		varchar(30) unique not null
);

insert into "publisher" values('PUB01', 'Addison-Wesley');	
insert into "publisher" values('PUB02', 'Morgan Kaufmann Publishers');	
insert into "publisher" values('PUB03', 'Kluwer Academic Publishers');	

insert into "book" values('B01','TCP/IP Illustrated', 1994, 'PUB01');
insert into "book" values('B02','Advanced Programming in the Unix environment', 1992, 'PUB01');
insert into "book" values('B03','Data on the Web', 2000, 'PUB02');
insert into "book" values('B04','The Economics of Technology and Content for Digital TV', 1999, 'PUB03');

insert into "person" values('P01', 'W.', 'Stevens', '');
insert into "person" values('P02', 'Serge', 'Abitboul', '');
insert into "person" values('P03', 'Peter', 'Buneman', '');
insert into "person" values('P04', 'Dan', 'Suciu', '');
insert into "person" values('P05', 'Darcy', 'Gerbarg', 'CITI');

insert into "author" values('B01', 'P01', 1);
insert into "author" values('B02', 'P01', 1);
insert into "author" values('B03', 'P02', 1);
insert into "author" values('B03', 'P03', 2);
insert into "author" values('B03', 'P04', 3);

insert into "editor" values('B04', 'P05', 1);
