module namespace ns = "http://www.xquark.org/XQuery/Samples/viewDefs";
import schema namespace bib = "http://www.xquark.org/XQuery/use-cases/bib" at "bib.xsd";
import schema namespace r = "http://www.xquark.org/XQuery/use-cases/reviews" at "reviews.xsd";
import schema namespace p = "http://www.xquark.org/XQuery/use-cases/prices" at "prices.xsd";

declare function ns:bib() as element(bib:bib) {
	<bib:bib>
		{
			for $b in collection("book")/*:book
			order by $b/id
			return 
				<book year="{$b/year}">
					{ $b/title }
					{
						for $a in collection("author")/*:author,
							$p in collection("person")/*:person
						where $a/bookid = $b/id and $a/personid = $p/id
						order by $a/rank
						return
							<author>
								{ $p/last }
								{ $p/first }
							</author>
					}
					{
						for $e in collection("editor")/*:editor,
							$p in collection("person")/*:person
						where $e/bookid = $b/id and $e/personid = $p/id
						order by $e/rank
						return
							<editor>
								{ $p/last }
								{ $p/first }
								{ $p/affiliation }
							</editor>
					}
					{
						for $pub in collection("publisher")/*:publisher
						where $pub/id = $b/pubid
						return
							<publisher>{ data($pub/name) }</publisher>
					}
					{ 
						for $price in doc("prices.xml")/p:prices/book
						where $price/source = "www.bn.com" and $b/title = $price/title
						return
							<price>{ data($price/price) }</price> 
					}
				</book>
		}
	</bib:bib>
};

declare function ns:reviews() as element(r:reviews) {
	doc("reviews.xml")/r:reviews
};

declare function ns:prices() as element(p:prices) {
	doc("prices.xml")/p:prices
}
