module namespace ns = "http://items.org";
import schema namespace bid = "http://www.xquark.org/XQuery/use-cases/bids" at "bids.xsd";

declare function ns:items() {
  for $i in collection("items")/*:items
  order by $i/itemno
  return
	<item>
		{ $i/description }
		{ 
			for $u in collection("users")/*:users
			where $u/userid = $i/offered_by
			return  
				<owner>
					{ $u/name }
					{ $u/rating }
				</owner>
		}
		<auction>
			<start>{ data($i/start_date) }</start>
			<end>{ data($i/end_date) }</end>
			<reserve>{ data($i/reserve_price) }</reserve>
			<highest>{ max(for $b in doc("bids.xml")/bid:bids/bid_tuple where $b/itemno = $i/itemno return $b/bid) }</highest>
		</auction>
		<bids>
		{ 
			for $b in doc("bids.xml")/bid:bids/bid_tuple
			where $b/itemno = $i/itemno
			order by $b/bid_date
			return  
				<bid>
					<value>{ data($b/bid) }</value>
					<date>{ data($b/bid_date) }</date>
					{ for $u2 in collection("users")/*:users
					  where $u2/userid = $b/userid
					  return  
					  <bidder>{ data($u2/name) }</bidder>
					}
				</bid>
		}
		</bids>
	</item>
};
